#include <Windows.h>
#include <tchar.h>

#include "direct3d.h" 
#include "texture.h"
#include "sprite.h"
#include "font.h"



// EBhEvV[WAEBhEɑ΂郁bZ[Ws
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	
	switch(msg){
		// EBhEjꂽƂ
	case WM_DESTROY:
		PostQuitMessage(0);	// WM_QUITbZ[WbZ[WL[ɑ
		return 0;
	}
	// ftHg̃bZ[Ws
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

// WinMain֐iAvP[V̊Jn֐j
// R\[AvP[VƈႢAR\[JȂ
int _stdcall WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	const TCHAR* WC_BASIC = _T("BASIC_WINDOW");
	// VvEBhENXݒ
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS,WndProc, 0,0,hInstance,
		(HICON)LoadImage(NULL,MAKEINTRESOURCE(IDI_APPLICATION),IMAGE_ICON,0,0,LR_DEFAULTSIZE | LR_SHARED),
		(HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED), 
		(HBRUSH)GetStockObject(WHITE_BRUSH), NULL, WC_BASIC , NULL};

	// VvEBhENX쐬
	if(!RegisterClassEx(&wcex)) 
		return false;

	// EBhEA̓fBXvCɈˑBʂ4:3
	const int WINDOW_WIDTH = 640;
	const int WINDOW_HEIGHT = 480;
	// EBhE̍쐬
	HWND hWnd = CreateWindowEx(0,WC_BASIC,
		_T("Application"), WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,WINDOW_WIDTH,WINDOW_HEIGHT,NULL,NULL,hInstance,NULL);

///////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////
	//	Direct3D̏
	////////////////////////////////////
	Direct3D direct3d;
	direct3d.Create(hWnd,WINDOW_WIDTH,WINDOW_HEIGHT);

	////////////////////////////////////
	//	eNX`쐬
	////////////////////////////////////
	Texture cartex;
	cartex.Load(direct3d.pDevice3D,_T("car.bmp"));

	////////////////////////////////////
	//	XvCg쐬
	////////////////////////////////////
	Sprite sprite[2];
	sprite[0].SetWidth(128,128);
	sprite[0].SetPos(200,200);
	sprite[0].SetRotate(D3DX_PI/4.0f);
	
	sprite[1].SetWidth(128,128);
	sprite[1].SetPos(400,200);

	////////////////////////////////
	// tHg쐬
	////////////////////////////////
	DirectXText text;
	text.Create(direct3d.pDevice3D,32);

///////////////////////////////////////////////////////////////////////////////////////////////
		
	// bZ[W[v
	MSG msg = {}; 
	while(msg.message != WM_QUIT) {
		// AvP[VɑĂ郁bZ[WbZ[WL[擾
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			DispatchMessage(&msg);	// AvP[V̊eEBhEvV[WɃbZ[W]
		}
		// bZ[WĂȂƂ
		else{
			//iDirectX̏j

///////////////////////////////////////////////////////////////////////////////////////////////

			// `Jn
			if(SUCCEEDED(direct3d.pDevice3D->BeginScene()))
			{
				DWORD ClearColor = 0xff808080;	// wiNAF
				// wiNA
				direct3d.pDevice3D->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_STENCIL | D3DCLEAR_ZBUFFER, ClearColor, 1.0f, 0 );
		
				const float speed = 2.0f;
				D3DXVECTOR2 vec;
				vec.x = 0.0f;
				vec.y = 0.0f;
				if(GetAsyncKeyState('W'))
					vec.y -= 1.0f;
				if(GetAsyncKeyState('S'))
					vec.y += 1.0f;
				if(GetAsyncKeyState('A'))
					vec.x -= 1.0f;
				if(GetAsyncKeyState('D'))
					vec.x += 1.0f;
				// K
				D3DXVec2Normalize(&vec,&vec);
				vec *= speed;
				// sړ
				sprite[1].UpdatePos(vec.x,vec.y);


				float rot = 0.0f;
				float rotspeed = 1.0f/36.0f;
				if(GetAsyncKeyState('R'))
					rot += D3DX_PI * rotspeed;
				if(GetAsyncKeyState('T'))
					rot -= D3DX_PI * rotspeed;
				// ]
				sprite[1].UpdateRotate(rot);

				// 摜`
				for(int i = 0;i < 2;++i)
					sprite[i].Draw(direct3d.pDevice3D,cartex.pTexture);

				// `
				text.Draw(0xffff0000,0,0,_T("x = %.1f y = %.1f\n"),sprite[1].pos.x,sprite[1].pos.y);
				if(IsHitTest(sprite[0],sprite[1]))
					text.Draw(0xffff0000,0,32,_T("܂\n"));

				// `I
				direct3d.pDevice3D->EndScene();
			}
			// `攽f
			direct3d.pDevice3D->Present( NULL, NULL, NULL, NULL );

///////////////////////////////////////////////////////////////////////////////////////////////
		}
	}

	
	return 0;
}